/**
 * Copyright (C) 2018 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#define _GNU_SOURCE
#include <sys/types.h>
#include <sys/wait.h>
#include <openssl/bio.h>
#include <openssl/x509.h>
#include <openssl/err.h>

unsigned char bad_bio[] = {
  0x30, 0x84, 0x7f, 0xff, 0xff, 0xff, 0xff, 0xff,
  0xff, 0xff
};


X509 *cert;

int main(void){
  unsigned long err = 0;
  ERR_load_crypto_strings();
  BIO *in = BIO_new(BIO_s_mem());
  if(in != NULL){
    BIO_write(in, bad_bio, sizeof(bad_bio));
    cert = d2i_X509_bio(in, NULL); // x509 should be present on all Android systems
    BIO_free(in);
    if(cert != NULL){
      X509_free(cert);
    }
    if((err = ERR_get_error())
        == 0x07000041) // malloc error
      return 113;
  }
}
